﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Microsoft.Win32;

namespace Spread_WPF_Ribbon
{
    /// <summary>
    /// Interaction logic for SpreadRibbonWindow.xaml
    /// </summary>
    public partial class SpreadRibbonWindow
    {
        GrapeCity.Windows.SpreadSheet.Data.CellRange cr = new GrapeCity.Windows.SpreadSheet.Data.CellRange(0, 0, 1, 1);
        public SpreadRibbonWindow()
        {
            InitializeComponent();
            this.HookEvents();
        }

        private void HookEvents()
        {
            this.gcSpread1.ActiveSheet.SelectionChanged += new EventHandler<GrapeCity.Windows.SpreadSheet.Data.SheetSelectionChangedEventArgs>(OnSelectionChanged);
        }

        private void OnSelectionChanged(object sender, GrapeCity.Windows.SpreadSheet.Data.SheetSelectionChangedEventArgs e) {
            cr = new GrapeCity.Windows.SpreadSheet.Data.CellRange(e.Row, e.Column, e.RowCount, e.ColumnCount);
        }

        private void copyButton_Click(object sender, RoutedEventArgs e)
        {
            //GrapeCity.Windows.SpreadSheet.Data.CellRange cr;
            //GrapeCity.Windows.SpreadSheet.Data.Cell activeCell = gcSpread1.ActiveSheet.ActiveCell;
            //cr = new GrapeCity.Windows.SpreadSheet.Data.CellRange(activeCell.Row.Index, activeCell.Column.Index, (activeCell.Row.Index2 - activeCell.Row.Index), (activeCell.Column.Index2 - activeCell.Column.Index));
            this.gcSpread1.View.ClipboardCopy(cr);
        }

        private void cutButton_Click(object sender, RoutedEventArgs e)
        {
            this.gcSpread1.View.ClipboardCut(cr);
        }

        private void pasteButton_Click(object sender, RoutedEventArgs e)
        {
            this.gcSpread1.View.ClipboardPaste(cr);
        }

        private void insertRowButton_Click(object sender, RoutedEventArgs e)
        {
            this.gcSpread1.ActiveSheet.AddRows(this.gcSpread1.ActiveSheet.ActiveRow.Index, 1);
        }

        private void removeRowButton_Click(object sender, RoutedEventArgs e)
        {
            this.gcSpread1.ActiveSheet.RemoveRows(this.gcSpread1.ActiveSheet.ActiveRow.Index, 1);
        }

        private void insertColumnButton_Click(object sender, RoutedEventArgs e)
        {
            this.gcSpread1.ActiveSheet.AddColumns(this.gcSpread1.ActiveSheet.ActiveColumn.Index, 1);
        }

        private void removeColumnButton_Click(object sender, RoutedEventArgs e)
        {
            this.gcSpread1.ActiveSheet.RemoveColumns(this.gcSpread1.ActiveSheet.ActiveColumn.Index, 1);
        }

        private void openButton_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Excel Files (*.xlsx)|*.xlsx|All files (*.*)|*.*";
            String fileName = "";
            if (ofd.ShowDialog() == true)
                fileName = ofd.FileName;
            if (fileName != "")
                gcSpread1.OpenExcel(fileName);
        }

        private void saveButton_Click(object sender, RoutedEventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "Excel Files (*.xlsx)|*.xlsx|All files (*.*)|*.*";
            String fileName = "";
            if (sfd.ShowDialog() == true)
                fileName = sfd.FileName;
            if (fileName != "")
                gcSpread1.SaveExcel(fileName, GrapeCity.Windows.SpreadSheet.Data.ExcelFileFormat.XLSX);
        }
    }
}
